--- old/usr/src/uts/common/os/zone.c	Fri Jan 29 20:31:01 2016
+++ new/usr/src/uts/common/os/zone.c	Fri Jan 29 20:31:01 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2013, Joyent Inc. All rights reserved.
+ * Copyright 2016 Garrett D'Amore
  */
 
 /*
@@ -1837,6 +1838,8 @@
 	scalehrtime(&tmp);
 	zmp->zm_wtime.value.ui64 = tmp;
 
+	zmp->zm_boot_hrtime.value.t = zone->zone_boot_hrtime;
+
 	zmp->zm_avenrun1.value.ui32 = zone->zone_avenrun[0];
 	zmp->zm_avenrun5.value.ui32 = zone->zone_avenrun[1];
 	zmp->zm_avenrun15.value.ui32 = zone->zone_avenrun[2];
@@ -1884,6 +1887,7 @@
 	    KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_ffnomem, "forkfail_nomem", KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_ffmisc, "forkfail_misc", KSTAT_DATA_UINT32);
+	kstat_named_init(&zmp->zm_boot_hrtime, "boot_hrtime", KSTAT_DATA_TIME);
 
 
 	ksp->ks_update = zone_misc_kstat_update;
@@ -3965,6 +3969,7 @@
 			mutex_exit(&zone_status_lock);
 		} else {
 			zone->zone_boot_time = gethrestime_sec();
+			zone->zone_boot_hrtime = gethrtime();
 		}
 
 		pool_unlock();
